Imports System.Web
Imports System.Diagnostics
Imports Microsoft.VisualBasic

Partial Class DebugInfo
    Inherits Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim objCurrentInfo As ProcessInfo = ProcessModelInfo.GetCurrentProcessInfo()
        lblProcID.Text = objCurrentInfo.ProcessID
        lblStartTime.Text = objCurrentInfo.StartTime
        lblRunningTime.Text = objCurrentInfo.Age.Days & " days, " & objCurrentInfo.Age.Hours & ":" & objCurrentInfo.Age.Minutes
        lblPeakMem.Text = objCurrentInfo.PeakMemoryUsed
        lblStatus.Text = objCurrentInfo.Status.ToString

        Try
            Dim perfCounter As New PerformanceCounter("Memory", "Available MBytes")
            lblFreeMem.Text = perfCounter.NextValue() & " MB"
            perfCounter = New PerformanceCounter("PhysicalDisk", "Avg. Disk Queue Length", "_Total")
            lblDiscQ.Text = perfCounter.NextValue()
            perfCounter = New PerformanceCounter("Processor", "Interrupts/sec", "_Total")
            lblCPU.Text = perfCounter.NextValue()
        Catch ex As Exception
            lblCPU.Text = ex.Message
        End Try

        dgHistory.DataSource = ProcessModelInfo.GetHistory(10)
        dgHistory.DataBind()

        For Each drive As System.IO.DriveInfo In System.IO.DriveInfo.GetDrives
            If drive.IsReady Then
                If lblDiscFree.Text <> String.Empty Then lblDiscFree.Text &= ", "
                lblDiscFree.Text &= drive.Name & " = " & (drive.AvailableFreeSpace / (1024 * 1024)).ToString("0.0") & " MB"
            End If
        Next

        GetCounterCat("ASP.NET")
        GetCounterCat("ASP.NET Applications")
        'GetCounterCat("ASP.NET State Service")
    End Sub

    Sub GetCounterCat(ByVal categoryName As String)
        Dim pcc As PerformanceCounterCategory
        Dim counters() As PerformanceCounter
        Try
            pcc = New PerformanceCounterCategory(categoryName)
            counters = pcc.GetCounters()
        Catch ex As Exception
            Trace.Write("Unable to get counter information for " & categoryName)
            Trace.Write(ex.Message)
            Return
        End Try
        ' Display the counter names if GetCounters was successful.
        If Not counters Is Nothing Then
            Dim ContentRow As New TableRow

            For intCounter As Integer = 0 To counters.Length - 1
                ContentRow = New TableRow
                ContentRow.Cells.Add(BodyCell(counters(intCounter).CounterName))
                ContentRow.Cells.Add(BodyCell(counters(intCounter).NextValue))
                tblASPCounters.Rows.Add(ContentRow)
            Next
        End If
    End Sub

    Function BodyCell(ByVal HeaderText As String) As TableCell
        Dim ContentCell As New TableCell
        ContentCell.Text = HeaderText
        Return ContentCell
    End Function
End Class
